<template>
  <form @submit.prevent="$emit('submit')">
    <div class="field">
      <label class="label">Name</label>
      <div class="control">
        <p v-if="readonly">{{ name }}</p>
        <input
          v-else
          :value="name"
          @input="$emit('update:name', $event.target.value)"
          class="input"
          type="text"
          placeholder="Name"
          autofocus
        >
      </div>
    </div>
    <div class="field">
      <label class="label">Description</label>
      <div class="control">
        <p v-if="readonly">{{ description }}</p>
        <textarea
          v-else
          class="textarea"
          placeholder="Descrition"
          :value="description"
          @input="$emit('update:description', $event.target.value)"
        />
      </div>
    </div>
    <div v-if="!readonly" class="buttons">
      <button
        type="submit"
        class="button is-primary"
        :class="{ 'is-loading': loading }"
        :disabled="!validate"
      >{{ button }}</button>
      <button
        type="button"
        class="button is-primary"
        :disabled="loading"
        @click="$emit('cancel')"
      >Cancel</button>
    </div>
  </form>
</template>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';
  import { Prop } from 'vue-property-decorator';

  @Component<ItemTypeDetail>({})
  export default class ItemTypeDetail extends Vue {
    @Prop({
      type: Boolean,
      default: false,
    }) readonly!: boolean;

    @Prop({
      type: String,
      required: true,
    }) name!: string;

    @Prop({
      type: String,
      required: true,
    }) description!: string;

    @Prop({
      type: String,
      default: 'Create',
    }) button!: string;

    @Prop({
      type: Boolean,
      default: false,
    }) loading!: boolean;

    get validate() {
      return (
        !!this.name && this.name.trim().length > 0 &&
        !!this.description && this.description.trim().length > 0
      );
    }
  }
</script>
